#include <stdio.h>
#include <time.h>
#include <string.h>
#include "FtdcTraderApi.h"

// Ա
TShfeFtdcParticipantIDType g_chParticipantID = "";						//ҪݲԻ޸
// û
TShfeFtdcUserIDType g_chUserID = "222001";								//ҪݲԻ޸

class CSimpleHandler : public CShfeFtdcTraderSpi
{
public:
	// 캯ҪһЧָCShfeFtdcTraderApiʵָ
	CSimpleHandler(CShfeFtdcTraderApi *pTraderApi) : m_pTraderApi(pTraderApi) 
	{
	}

	~CSimpleHandler() {}
	
	virtual void OnPackageStart(int nTopicID, int nSequenceNo)
	{
		printf("OnPackageStart:%d %d\n", nTopicID, nSequenceNo);
	}
	
	virtual void OnPackageEnd(int nTopicID, int nSequenceNo)
	{
		printf("OnPackageEnd:%d %d\n", nTopicID, nSequenceNo);
	}

	virtual void OnRspSubscribeTopic(CShfeFtdcDisseminationField *pDissemination, CShfeFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) 
	{
		printf("OnRspSubscribeTopic:%d %d\n", pDissemination->SequenceSeries,
			pDissemination->SequenceNo);
	};

	virtual void OnRtnInsInstrument(CShfeFtdcInstrumentField *pInstrument)
	{
		printf("OnRtnInsInstrument:%s\n", pInstrument->InstrumentID);
	};
	// ͻ뽻׺̨ͨӣͻҪе¼
	virtual void OnFrontConnected()
	{
		CShfeFtdcReqUserLoginField reqUserLogin;
		// ½
		strcpy(reqUserLogin.ParticipantID, g_chParticipantID);
		strcpy(reqUserLogin.UserID, g_chUserID);
		strcpy(reqUserLogin.Password, "");									//ҪݲԻ޸								
		m_pTraderApi->ReqUserLogin(&reqUserLogin, 0);
	}
	
	// ͻ뽻׺̨ͨӶϿʱ÷
	virtual void OnFrontDisconnected(int nReason)
	{
		// APIԶӣͻ˿ɲ
		printf("OnFrontDisconnected.\n");
	}

	// ͻ˷¼֮󣬸÷ᱻã֪ͨͻ˵¼Ƿɹ
	virtual void OnRspUserLogin(CShfeFtdcRspUserLoginField *pRspUserLogin, CShfeFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
	{
		printf("OnRspUserLogin:\n");
		printf("ErrorCode=[%d], ErrorMsg=[%s]\n", pRspInfo->ErrorID, pRspInfo->ErrorMsg);
		printf("RequestID=[%d], Chain=[%d]\n", nRequestID, bIsLast);

		if (pRspInfo->ErrorID != 0) {
			// ˵ʧܣͻд
			printf("Failed to login, errorcode=%d errormsg=%s requestid=%d chain=%d", pRspInfo->ErrorID, pRspInfo->ErrorMsg, nRequestID, bIsLast);
//			exit(-1);
		}

		
		CShfeFtdcInputOrderField ord;
		
		// ¼ɹ,¼
		memset(&ord, 0, sizeof(ord));
		
		// Ա
		strcpy(ord.ParticipantID, g_chParticipantID);
		// ͻ
		strcpy(ord.ClientID, "30000011");									//ҪݲԻ޸
		// û
		strcpy(ord.UserID, g_chUserID);
		// Լ
		strcpy(ord.InstrumentID, "cu0709");									//ҪݲԻ޸
		// ۸
		ord.OrderPriceType = SHFE_FTDC_OPT_LimitPrice;
		// 
		ord.Direction = SHFE_FTDC_D_Buy;
		// Ͽƽ־
		strcpy(ord.CombOffsetFlag, "0");
		// Ͷױ־
		strcpy(ord.CombHedgeFlag, "1");
		// ۸
		ord.LimitPrice = 75000;												//ҪݲԻ޸
		// 
		ord.VolumeTotalOriginal = 10;
		// Ч
		ord.TimeCondition = SHFE_FTDC_TC_GFD;
		// GTD
		strcpy(ord.GTDDate, "");
		// ɽ
		ord.VolumeCondition = SHFE_FTDC_VC_AV;
		// Сɽ
		ord.MinVolume = 0;
		// 
		ord.ContingentCondition = SHFE_FTDC_CC_Immediately;
		// ֹ
		ord.StopPrice = 0;
		// ǿƽԭ
		ord.ForceCloseReason = SHFE_FTDC_FCC_NotForceClose;
		// ر
		strcpy(ord.OrderLocalID, "0000000002");								//ҪݲԻ޸
		// Զ־
		ord.IsAutoSuspend = 0;
		m_pTraderApi->ReqOrderInsert(&ord, 1);

	}

	// ¼Ӧ
	virtual void OnRspOrderInsert(CShfeFtdcInputOrderField *pInputOrder, CShfeFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
	{
		// ¼
		printf("OnRspOrderInsert:ErrorCode=[%d], ErrorMsg=[%s]\n", pRspInfo->ErrorID, pRspInfo->ErrorMsg);
	};
	
	///ر
	virtual void OnRtnOrder(CShfeFtdcOrderField *pOrder)
	{
		static int s_nOrderCount = 0;
		s_nOrderCount++;
		if (s_nOrderCount %100 == 0)
		{
			printf("%d\n", time(NULL));
		}
//		printf("OnRtnOrder:\n");
//		printf("OrderSysID=[%s]\n", pOrder->OrderSysID);
	}

	// ûĳ֪ͨ
	virtual void OnRspError(CShfeFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {
		printf("OnRspError:\n");
//		printf("ErrorCode=[%d], ErrorMsg=[%s]\n", pRspInfo->ErrorID, pRspInfo->ErrorMsg);
		printf("RequestID=[%d], Chain=[%d]\n", nRequestID, bIsLast);
	}

private:
	// ָCShfeFtdcMduserApiʵָ
	CShfeFtdcTraderApi *m_pTraderApi;
};

int main(int argc, char *argv[])
{
	// һCShfeFtdcTraderApiʵ
	CShfeFtdcTraderApi *pTraderApi = CShfeFtdcTraderApi::CreateFtdcTraderApi();

	int nMajorVersion = 0, nMinorVersion = 0;

	const char *pVersionInfo = pTraderApi->GetVersion(nMajorVersion, nMinorVersion);
	printf("version:%s, %d.%d\n", pVersionInfo, nMajorVersion, nMinorVersion);

	// һ¼ʵ
	CSimpleHandler sh(pTraderApi);
	// עһ¼ʵ
	pTraderApi->RegisterSpi(&sh);
	
	// ˽
	//        TERT_RESTART:ӱտʼش
	//        TERT_RESUME:ϴյ
	//        TERT_QUICK:ֻ͵¼˽
	pTraderApi->SubscribePrivateTopic(TERT_RESTART);
	
	// Ĺ
	//        TERT_RESTART:ӱտʼش
	//        TERT_RESUME:ϴյ
	//        TERT_QUICK:ֻ͵¼󹫹
	pTraderApi->SubscribePublicTopic(TERT_RESTART);

	// ý׺̨ĵַ
	pTraderApi->RegisterFront("tcp://172.16.30.31:49205");
//	pTraderApi->RegisterNameServer("tcp://172.16.1.15:4601");
	// ʹͻ˿ʼ̨
	pTraderApi->Init();
	
	pTraderApi->Join();
	
	// ͷAPIʵ
	pTraderApi->Release();

	return 0;
}

